local Bezier_pos = {1,1,0,0} --Ƶ
local moing = false --״̬
local moingpos = 0
local ctrl = false
local time = 0
function getBezier(startTime, endTime, startValue, endValue, bezierTable,nowtime)
    -- ʱʱ䷶Χڵİٷֱ
    local timePercent = (nowtime - startTime) / (endTime - startTime)
    
    -- ʱ䷶Χ01֮
   -- timePercent = math.max(0, math.min(1, timePercent))
    
    -- 㱴ߵĲֵ
    local p0 = {0, 0}  -- 
    local p1 = {bezierTable[1], bezierTable[2]}  -- Ƶ1
    local p2 = {bezierTable[3], bezierTable[4]}  -- Ƶ2
    local p3 = {1, 1}  -- յ
    
    local t = timePercent
    local u = 1 - t
    local tt = t * t
    local uu = u * u
    local uuu = uu * u
    local ttt = tt * t
    
    local x = uuu * p0[1] + 3 * uu * t * p1[1] + 3 * u * tt * p2[1] + ttt * p3[1]
    local y = uuu * p0[2] + 3 * uu * t * p1[2] + 3 * u * tt * p2[2] + ttt * p3[2]
    
    -- ݲֵֵ
    local value = startValue + (endValue - startValue) * y
    
    return value
end
function love.load()
   love.window.setMode(1000,700)
    love.window.setTitle("Bezier")
end

function love.update(dt)
--λü
   mousex, mousey = love.mouse.getPosition()
   bzpos1 = {Bezier_pos[1] * 500 + 250,(1 - Bezier_pos[2]) * 300 + 200}
   bzpos2 = {Bezier_pos[3] * 500 + 250,(1 - Bezier_pos[4]) * 300 + 200}
   if moing == true and moingpos == 1 then
     bzpos1 = {mousex,mousey}
     Bezier_pos[1],Bezier_pos[2] = (bzpos1[1] -250) / 500 ,1 - ( (bzpos1[2] -200) / 300)
   end
   if moing == true and moingpos == 2 then
     bzpos2 = {mousex,mousey}
     Bezier_pos[3],Bezier_pos[4] = (bzpos2[1] -250) / 500 , 1 -((bzpos2[2] -200) / 300)
   end
   time = time + dt
   if time >= 1 then
      time = 0
   end
   --ͼʾ
end
function love.draw()
  love.graphics.setColor(1,1,1,1)
   love.graphics.rectangle("fill",getBezier(0,1,250,750,Bezier_pos,time),550,10,10) --˶


  love.graphics.print("COPY :ctrl + c",700,50)
  love.graphics.print("Bezier",700,600)
  love.graphics.setColor(0,1,1,1)
  for i = 0 ,500,0.01 do
       love.graphics.rectangle("fill",i + 250,getBezier(0,500,500,200,Bezier_pos,i),2,4)
  end
  love.graphics.setColor(1,1,1,1)
  for i = 1 ,4 do
     if i == 1 or i == 2 then
        love.graphics.setColor(1,1,0)
     else
        love.graphics.setColor(1,0,1)
     end
     love.graphics.print(Bezier_pos[i],100,50*i)
  end
  love.graphics.setColor(1,1,0)
  love.graphics.circle("line",bzpos1[1],bzpos1[2],20)
  love.graphics.setColor(1,0,1)
  love.graphics.circle("line",bzpos2[1],bzpos2[2],20)


  love.graphics.setColor(1,1,1)
   love.graphics.rectangle("fill",250,500,500,5)
    love.graphics.rectangle("fill",750,200,5,305)
end

function love.mousepressed(x, y, button)
   moing = true
   if x <= bzpos1[1] + 20 and y <= bzpos1[2] + 20 and x >= bzpos1[1] - 20 and y >= bzpos1[2] - 20 then
     moingpos = 1
   elseif x <= bzpos2[1] + 20 and y <= bzpos2[2] + 20 and x >= bzpos2[1] - 20 and y >= bzpos2[2] - 20 then
     moingpos = 2
   else
     moingpos = 0
   end
end

function love.mousereleased(button,x,y)
   moing = false
end


function love.keypressed(key)
   if key == "lctrl" or key == "rctrl" then
    ctrl = true
   end
   if key == "c" and ctrl == true then
      love.system.setClipboardText(Bezier_pos[1]..","..Bezier_pos[2]..","..Bezier_pos[3]..","..Bezier_pos[4])
   end
end
function love.keyreleased(key)
     ctrl = false
end
